#!/bin/sh

intro()
{
    printf "%-40s" "$*..."
}

die()
{
    [ "$1" ] && echo "$@"
    exit 1
}

printout()
{
    echo "********************************************************************"
    echo "$out"
    echo "********************************************************************"
}

dir="$0"
exec=`basename $0`
dir=${dir/%$exec}
cd $dir
unset dir exec

#--------------------------------------------------------------------------
# smoke tests
intro "Smoke: test 1"
./smoke1 || die

intro "Smoke: test 2"
./smoke2 || die

#--------------------------------------------------------------------------
# sanity tests
for method in dinput destabil osd doutput; do
    intro "Sanity: method $method"
    if out=`./sanity_$method`; then
        echo passed
    else
        echo failed
        printout
        exit 1
    fi
done

#--------------------------------------------------------------------------
# tests of extending
for method in dinput destabil osd doutput; do
    intro "Extending: method $method"
    if out=`./ext_$method`; then
        echo passed
    else
        echo failed
        printout
        exit 1
    fi
done

#--------------------------------------------------------------------------
# functional tests (smv is required to be in the PATH)
for method in dinput destabil osd doutput; do
    intro "Synchronization: method $method"
    if out=`./syn_$method`; then
        echo passed
    else
        echo failed
        printout
        exit 1
    fi
done
